/* This is the version of main() for DCL-style option parsing.  */

/* FIXME: Probably should be using init_cli from the VERB distribution
   so that we can be defined as a foreign command as well as by SET
   COMMAND.  */

#include <stdio.h>
#include <stdlib.h>
#include <descrip.h>
#include <string.h>
#include "vmsbackup.h"

extern int cli$get_value();
extern int cli$present();

int
main (argc, argv)
int argc;
char *argv[];
{
	static $DESCRIPTOR (file1,"P1");
	static $DESCRIPTOR (file2,"P2");
	static $DESCRIPTOR (q_list,"LIST");
	static $DESCRIPTOR (q_full,"FULL");
	static $DESCRIPTOR (q_brief, "BRIEF");
	static struct dsc$descriptor result =
		{0,DSC$K_DTYPE_T,DSC$K_CLASS_D,0};

	/* We don't yet have a mechanism to select only some files from
	   a save set.  */
	gargv = NULL;
	gargc = 0;
	goptind = 0;

	cflag=dflag=eflag=sflag=tflag=vflag=wflag=xflag=0;
	flag_full = 0;
	if (cli$get_value (&file1, &result) & 1) {
		/* FIXME: How do I find whether /SAVE_SET is there?  */
		tapefile = malloc (result.dsc$w_length + 1);
		if (tapefile == NULL) {
			fprintf (stderr, "out of memory!\n");
			exit (EXIT_FAILURE);
		}
		strncpy (tapefile, result.dsc$a_pointer, result.dsc$w_length);
		tapefile[result.dsc$w_length] = '\0';
	}
	if (cli$get_value (&file2, &result) & 1) {
		fprintf (stderr, "internal error: extraction not implemented");
		exit (EXIT_FAILURE);
	}
	if (cli$present (&q_list) & 1) {
		tflag = 1;
	}
	if (cli$present (&q_full) & 1) {
		flag_full = 1;
	}
	if (cli$present (&q_brief) & 1) {
		/* /BRIEF overrides /FULL.  */
		flag_full = 0;
	}

	xflag = !tflag;
	if (!tflag) {
		fprintf (stderr, "internal error: extraction not implemented");
		exit (EXIT_FAILURE);
	}
	vmsbackup ();
}
